﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.IO;
using System.Xml;
using System.Text;

namespace demoivr
{
    public partial class ivr : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            string xmlResult = "";
            
                //url示例：http://localhost:8012/ivr.aspx/startservice?appid=qw
                //xmlResult = strCatID;
                //云通讯回调请求页面的URL
                string str = Request.Path;

                if (str.Contains("startservice"))//云通讯IVR启动业务的回调请求，请求的url中固定相对地址startservice
                {
                    xmlResult = startservice();
                }
                else if (str.Contains("gettimeout"))//云通讯呼转命令的回调请求，通知第三方用户的按键超时，请求URL中的相对地址gettimeout可以自定义，demo中自定义为gettimeout
                {
                    xmlResult = gettimeout();
                }
                else if (str.Contains("dtmfreport"))//云通讯按键命令的回调请求，通知第三方用户的按键信息，请求URL中的相对地址dtmfreport可以自定义，demo中自定义为dtmfreport
                {
                    xmlResult = dtmfreport();
                }
                else if (str.Contains("stopservice"))//云通讯IVR结束业务的回调请求，请求的url中固定相对地址stopservice
                {
                    xmlResult = stopservice();
                }
                // 此处可以把自己定义的xml文件返回到调用者
                Response.Write(xmlResult);
                Response.End(); // 结束输出
            
        }

        private string dtmfreport()
        {
            string appid = Request.QueryString["appid"];//应用id
            string callid = Request.QueryString["callid"];//通话id，由云通讯平台产生的一路通话的唯一标识
            string digits = Request.QueryString["digits"];//用户按键内容
            //对云通讯平台回调请求的响应包体，响应的是放音提示后挂断用户电话
            string body = "<?xml version='1.0' encoding='UTF-8' ?><Response><Play>bye.wav</Play><Hangup/></Response>";
            return body;
        }
        //IVR结束业务，在用户挂机后由云通讯平台发起的回调请求
        private string stopservice()
        {
            string appid = Request.QueryString["appid"];//应用id
            string callid = Request.QueryString["callid"];//通话id，由云通讯平台产生的一路通话的唯一标识
            string starttime = Request.QueryString["starttime"];//主叫通话的开始时间
            string endtime = Request.QueryString["endtime"];//主叫通话的结束时间
            string callduration = Request.QueryString["callduration"];//主叫通话时长
            string sstime = Request.QueryString["sstime"];//被叫通话的开始时间
            string setime = Request.QueryString["setime"];//被叫通话的结束时间
            string seccallduration = Request.QueryString["seccallduration"];//被叫通话时间
            string recordurl = Request.QueryString["recordurl"];//录音文件下载地址
            string recordid = Request.QueryString["recordid"];//录音文件Id
            string errorcode = Request.QueryString["errorcode"];//通话中异常的错误值，可以根据错误知道出现异常的原因
            string body = "<?xml version='1.0' encoding='UTF-8' ?><Response><CmdNone/></Response>";
            return body;
        }
        //IVR启动业务，在IVR呼入或者IVR外呼后由云通讯平台发起的回调请求
        private string startservice()
        {
            string appid = Request.QueryString["appid"];//应用id
            string callid = Request.QueryString["callid"];//通话id，由云通讯平台产生的一路通话的唯一标识
            string from = Request.QueryString["from"];//主叫号码，当IVR呼入方式为主叫的号码，当IVR外呼的方式则为空
            string to = Request.QueryString["to"];//被叫号码，当IVR呼入方式为IVR接入号，当IVR外呼的方式则为外呼的号码
            string direction = Request.QueryString["direction"];//呼叫方式，IVR呼入为0，IVR外呼为1
            //对云通讯平台回调请求的响应包体，响应的是按键命令嵌套放音，超时没按键就放音提示用户后跳转到gettimeout
            //命令中action='dtmfreport'为自定义按键回调相对地址
            //numdigits='1'定义按键个数为1，当用户按任意一个键就会通知第三方服务器
            //timeout='20'为用户按键超时时间20秒，当放音第一次完成后开始计时，用户20秒没有按键就会执行副命令
            //loop='-1'为循环放音，当超时后停止
            string body = "<?xml version='1.0' encoding='UTF-8'?><Response><Get action='dtmfreport' numdigits='1' timeout='20'><Play loop='-1'>menu.wav</Play></Get><Play>timeout.wav</Play><Redirect>gettimeout</Redirect></Response>";
            return body;
        }
        
        //用户按键超时
        private string gettimeout()
        {
            string appid = Request.QueryString["appid"];//应用id
            string callid = Request.QueryString["callid"];//通话id，由云通讯平台产生的一路通话的唯一标识
            //对云通讯平台回调请求的响应包体，响应的是按键命令嵌套放音，超时没按键就放音提示用户后挂断用户
            string body = "<?xml version='1.0' encoding='UTF-8'?><Response><Get action='dtmfreport' numdigits='1' timeout='20'><Play loop='-1'>menu.wav</Play></Get><Play>timeoutbye.wav</Play><Hangup/></Response>";
            return body;
        }
    }
}